Index: asterisk/rtp.c
===================================================================
RCS file: /usr/cvsroot/asterisk/rtp.c,v
retrieving revision 1.92.2.15
diff -u -r1.92.2.15 rtp.c
--- asterisk/rtp.c	24 Jun 2005 21:53:02 -0000	1.92.2.15
+++ asterisk/rtp.c	14 Jul 2005 17:31:07 -0000
@@ -77,6 +77,7 @@
 	unsigned int lastividtimestamp;
 	unsigned int lastovidtimestamp;
 	unsigned int lasteventseqn;
+	unsigned int lasteventendseqn;
 	int lasttxformat;
 	int lastrxformat;
 	int dtmfcount;
@@ -234,7 +235,7 @@
 	return f;
 }
 
-static struct ast_frame *process_rfc2833(struct ast_rtp *rtp, unsigned char *data, int len)
+static struct ast_frame *process_rfc2833(struct ast_rtp *rtp, unsigned char *data, int len, unsigned int seqno)
 {
 	unsigned int event;
 	unsigned int event_end;
@@ -268,7 +269,10 @@
 	else if(event_end & 0x80)
 	{
 		if (rtp->resp) {
-			f = send_dtmf(rtp);
+			if(rtp->lasteventendseqn != seqno) {
+				f = send_dtmf(rtp);
+				rtp->lasteventendseqn = seqno;
+			}
 			rtp->resp = 0;
 		}
 		resp = 0;
@@ -490,7 +494,7 @@
 	  if (rtpPT.code == AST_RTP_DTMF) {
 	    /* It's special -- rfc2833 process it */
 	    if (rtp->lasteventseqn <= seqno || rtp->resp == 0 || (rtp->lasteventseqn >= 65530 && seqno <= 6)) {
-	      f = process_rfc2833(rtp, rtp->rawdata + AST_FRIENDLY_OFFSET + hdrlen, res - hdrlen);
+	      f = process_rfc2833(rtp, rtp->rawdata + AST_FRIENDLY_OFFSET + hdrlen, res - hdrlen, seqno);
 	      rtp->lasteventseqn = seqno;
 	    } else f = NULL;
 	    if (f) return f; else return &null_frame;
@@ -1090,7 +1094,7 @@
 			rtpheader[3] |= htonl((800));
 			/* Set the End bit for the last 3 */
 			rtpheader[3] |= htonl((1 << 23));
-		} else if ( x < 5) {
+		} else if ( x < 3) {
 			rtpheader[0] = htonl((2 << 30) | (payload << 16) | (rtp->seqno++));
 		}
 	}
